import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.*;

/**
 * Write a description of class RubixWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class RubixWorld extends World
{
    public static Face top,bottom,left,right,front,back;
    private static ArrayList<Face> faces = new ArrayList<Face>();
    public static final int CELL_SIZE = 5;
    public static final int TOP = 1, BOTTOM = 2, FRONT = 3, BACK = 4, RIGHT = 5, LEFT = 6;
    /**
     * Constructor for objects of class RubixWorld.
     * 
     */
    public RubixWorld()
    {    
        super(800/CELL_SIZE, 600/CELL_SIZE, CELL_SIZE); 
        setup();
    }

    public void setup() {
        top = new Face(Color.green,TOP);
        bottom = new Face(Color.white,BOTTOM);
        front = new Face(Color.blue,FRONT);
        back = new Face(Color.red,BACK);
        right = new Face(Color.orange,RIGHT);
        left = new Face(Color.yellow,LEFT);
        addAllFace();
        addLabelsForFaces();
        setPaintOrder(SquareOnFace.class, Face.class);
    }

    public void addAllFace() {
        addObject(top, 10, 20);
        addObject(bottom, 10, 75);
        addObject(front, 60, 20);
        addObject(back, 60, 75);
        addObject(right, 110, 20);
        addObject(left, 110, 75);
        faces.add(top);
        faces.add(bottom);
        faces.add(front);
        faces.add(back);
        faces.add(right);
        faces.add(left);
    }

    public void addLabelsForFaces() {
        Actor label = createLabel("Top");
        top.addTitle(label);
        label = createLabel("Bottom");
        bottom.addTitle(label);
        label = createLabel("Front");
        front.addTitle(label);
        label = createLabel("Back");
        back.addTitle(label);
        label = createLabel("Right");
        right.addTitle(label);
        label = createLabel("Left");
        left.addTitle(label);
    }

    public void act() {
        String key = Greenfoot.getKey();
        if(key == null) {
            return;
        }
        if(key.equals("r")) {
            new RubixWorld();
        }
        if(key.equals("s")) {
            startGame();
        }
    }

    public static Actor createLabel(final String text) {
        return new Label(text);
    }

    public static Face getFaceByDirection(int dir) {
        switch (dir) {
            case TOP:
            return top;
            case BOTTOM:
            return bottom;
            case FRONT:
            return front;
            case BACK:
            return back;
            case RIGHT:
            return right;
            case LEFT:
            return left;
            default:
            return null;
        }
    }

    /**
     * Fires an update on all faces
     */
    public static void update() {
        for(Face face : faces) {
            for(int i = 0; i < face.sq.length; i++) {
                SquareOnFace[] s1a = face.sq[i];
                for(int j = 0; j < s1a.length; j++) {
                    SquareOnFace s = s1a[j];
                    if(s == null) {
                        throw new IllegalStateException("Square missing: "+i+" "+j);
                    }
                    s.setLocation((i*15)+face.getOldX(), (j*15)+face.getOldY());
                }
            }
        }
    }

    /**
     * Starts the game by randomizing all the faces
     */
    public static void startGame() {
        for(int i = 0; i < 25; i++) {
            Face chosenFace = faces.get(Greenfoot.getRandomNumber(faces.size()));
            boolean counter = Greenfoot.getRandomNumber(100) > 50;
            if(counter) {
                chosenFace.counter();
            } else {
                chosenFace.clockwise();
            }
        }
        System.err.println("Recived s");
    }
}
